/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: ScriptBlockIterator.h,v 1.7 2002/07/23 07:44:37 yoshi Exp $ */ 
#ifndef ScriptBlockIterator_h
#define ScriptBlockIterator_h

#include <assert.h>
#include "ScriptBlockWalker.h"
#include "ScriptBlockWalkerUtil.h"

class ScriptBlockIterator
{
private:
	ScriptBlockWalker	*m_block;
	char			*m_lineBuffer;
	

	int	m_currx;
	int	m_curry;

private:
	char	position(int x, int y)
	{
		assert(m_block);
		return m_block->element(x, y);
	}
protected:
	char	*lineBuffer()
	{
		return (m_lineBuffer)?
			m_lineBuffer: (m_lineBuffer = new char [m_block->width() + 5]); // Ƒ傫߂ɂƂĂ
	}
public:
	ScriptBlockIterator(ScriptBlockWalker *p) : m_block(p), m_lineBuffer(0), m_currx(0), m_curry(0){;}
	ScriptBlockIterator() : m_block(0), m_lineBuffer(0), m_currx(0), m_curry(0){;}
	virtual ~ScriptBlockIterator() { if (m_lineBuffer) { delete [] m_lineBuffer; } }
	void set(ScriptBlockWalker *p) { m_block = p; }

	// ݂̈ʒu
	void	setPosition(int x, int y) { m_currx = x; m_curry = y; }
	int	currx() { return m_currx; }
	int	curry() { return m_curry; }

	// ͂̕
	virtual char	curr() { return position(m_currx, m_curry); }
	virtual char	right() { return position(m_currx+1, m_curry); }
	virtual char	left() { return position(m_currx-1, m_curry); }
	virtual char	up() { return position(m_currx, m_curry-1); }
	virtual char	down() { return position(m_currx, m_curry+1); }

	// ړ
	virtual bool 	moveLeft() { --m_currx; return true;}
	virtual bool 	moveRight() { ++m_currx; return true;}
	virtual bool	moveUp() { --m_curry; return true;}
	virtual bool 	moveDown() { ++m_curry; return true;}

	virtual void	skipBlankRight()
	{
		m_currx = ScriptBlockWalkerUtil::skipBlankRight(m_block, curry(), currx());
	}

	virtual char	*lineString() {
		char *buf = lineBuffer();
		char *p = buf;
		do { *p = curr(); p++; } while(moveRight());
		*p = '\0';
		return (buf[0] != '\0')? buf: 0;
	}

	void	freeLineBuffer(char *p) { if (p) { delete [] p; p = 0; } }
	int	totalLineIndex() { return m_block->totalLineIndex(curry()); }
	char	operator*() { return curr(); }
	ScriptBlockWalker *block() { return m_block; }
};


#endif  // ScriptBlockIterator_h
