/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: DrawPosition.cpp,v 1.4 2003/09/05 05:02:04 yoshi Exp $ */ 
#include "DrawPosition.h"

class DrawPositionMover : public DrawPositionOperator
{
private:
	int	shift(int value, const Length &d) const { return (value + d.value()); }
	int	shift(int value, int d) const { return (value + d); }
};
	
class StartDrawPositionOperator : public DrawPositionMover
{
private:
	int	start(int value, const Length &size) const{ return value; }
	int	center(int value, const Length &size) const { return (value + size.start_center()); }
	int	end(int value, const Length &size) const { return (value + size.value()); }
	int	start(int value, int size) const { return value; }
	int	center(int value, int size) const { return (value + size/2); }
	int	end(int value, int size) const { return (value + size); }
};

class CenterDrawPositionOperator : public DrawPositionMover
{
private:
	int	start(int value, const Length &size) const { return (value - size.start_center()); }
	int	center(int value, const Length &size) const { return value; }
	int	end(int value, const Length &size) const { return (value + (size.end_center())); }
	int	start(int value, int size) const { return (value - size/2); }
	int	center(int value, int size) const { return value; }
	int	end(int value, int size) const { return (value + size/2); }
};

class EndDrawPositionOperator : public DrawPositionMover
{
private:
	int	start(int value, const Length &size) const { return (value - size.value()); }
	int	center(int value, const Length &size) const { return (value - size.end_center()); }
	int	end(int value, const Length &size) const { return value; }
	int	start(int value, int size) const { return (value - size); }
	int	center(int value, int size) const { return (value - size/2); }
	int	end(int value, int size) const { return value; }
};

DrawPositionOperator *DrawPosition::getStart() const
{
	static StartDrawPositionOperator op;
	return &op;
}

DrawPositionOperator *DrawPosition::getCenter() const
{
	static CenterDrawPositionOperator op;
	return &op;
}

DrawPositionOperator *DrawPosition::getEnd() const
{
	static EndDrawPositionOperator op;
	return &op;
}
