/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: AlignmentEquation.h,v 1.7 2004/03/25 07:18:31 yoshi Exp $ */ 
#ifndef AlignmentEquation_h
#define AlignmentEquation_h

#include "ChildContainerEquation.h"
#include "EquationDrawerOperationDispatcher.h"

class Equation;

class AlignmentEquationDummy {};
class AlignmentEquation
	: public EquationDrawerOperationDispatcher<ChildContainerEquation, AlignmentEquationDummy>
{
public:
	typedef EquationDrawerOperationDispatcher<ChildContainerEquation, AlignmentEquationDummy> Super;
private:
	Equation	*m_left;
	Equation	*m_middle;
	Equation	*m_right;

public:
	AlignmentEquation() : Super(), m_left(0), m_middle(0), m_right(0) {;}

	void		left(Equation *p) { m_left = p; push(p); }
	void		middle(Equation *p) { m_middle = p; push(p); }
	void		right(Equation *p) { m_right = p; push(p); }

	Equation *	left() { return m_left; }
	Equation *	middle() { return m_middle; }
	Equation *	right() { return m_right; }
private:
	char *idName();
};

#endif  // AlignmentEquation_h
