/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: BracketEquation.h,v 1.11 2004/03/25 07:18:31 yoshi Exp $ */ 
#ifndef BracketEquation_h
#define BracketEquation_h

#include "ChildContainerEquation.h"
#include "EquationDrawerOperationDispatcher.h"
#include "EquationUtil.h"

class BracketEquationDummy {};
typedef EquationDrawerOperationDispatcher<ChildContainerEquation, BracketEquationDummy> BracketEquationSuper;
class BracketEquation : public BracketEquationSuper
{
public:
	enum Shape { SHAPE_NOT_SET = -1,
		     SHAPE_ROUND, SHAPE_BRACE, SHAPE_SQUARE,
		     SHAPE_FLOOR, SHAPE_CEIL, SHAPE_ANGLE,
		     SHAPE_NUM, };

private:
	enum Visible {
		INVISIBLE = 0,
		LEFT_VISIBLE = 0x01,
		RIGHT_VISIBLE = 0x02,
	};
public:
	typedef BracketEquationSuper Super;
private:
	Shape		m_left;
	Shape		m_right;
	unsigned	m_visible;
	
	Equation	*m_content;

public:
	BracketEquation(Shape left_,  Shape right__, bool leftVisible_, bool rightVisible_);

	Shape		left() const { return m_left; }
	Shape		right() const { return m_right; }

	void		content(Equation *p) { m_content = p; push(p);}
	Equation *	content() const  { return m_content; }
	bool		leftVisible() const { return (m_visible & LEFT_VISIBLE)? true: false; }
	bool		rightVisible() const { return (m_visible & RIGHT_VISIBLE)? true: false; }

private:
	char *idName();
	
};

#endif  // BracketEquation_h
