/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: Equation.h,v 1.14 2004/03/25 07:18:33 yoshi Exp $ */ 
#ifndef Equation_h
#define Equation_h

#include <assert.h>

#ifdef DRAW2D
#include "EquationSize.h"
#endif

#ifdef WIN32
#pragma warning(disable:4390)
#endif

class DrawContext;

class Equation
{
public:
	virtual char *idName() = 0;
	virtual void 	draw(DrawContext *context = 0) = 0;

	// ̐Ƃ́Aȉ̃\bh邱

	virtual Equation *child(int i) { return 0; }

	virtual bool containChild()
	{
		return (child(0))? true: false;
	}

	virtual bool containCondition();
	virtual bool containEnumerator();
	virtual bool enumerate();
	virtual bool isMatrix() { return false; }
	virtual bool isDefinition() { return false; }
	virtual bool isCondition() { return false; }

#ifdef DRAW2D
public:
	typedef EquationSize Size;
private:
	Size	*m_size;
	Length	m_center;

protected:
	virtual void    size(DrawContext *, Size &) = 0;
	virtual const Length &centerWidth(DrawContext *context, Length &l) = 0;

public:
	Equation() : m_size(0) {;}
	virtual ~Equation() { if (m_size) { delete m_size; m_size = 0; } }

	virtual Size * size(DrawContext *context)
	{
		if (!m_size) {
			m_size = new Size;
			size(context, *m_size);
		}
		return m_size;
	}
	
	const Length &centerWidth(DrawContext  *context)
	{
		centerWidth(context, m_center);
		return m_center;
	}

	virtual char *tag() { return 0; }
#endif
#ifdef _DEBUG
	void dump(int level);
#else
	void dump(int level) {;}
#endif

};

#endif  // Equation_h
