/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: EquationDrawerOperationDispatcher.h,v 1.1 2004/04/22 08:27:58 yoshi Exp $ */ 
#ifndef EquationDrawerOperationDispatcher_h
#define EquationDrawerOperationDispatcher_h

#include <assert.h>
#include "EquationDrawer.h"

class DrawContext;

template<class Super, class Dummy>
class EquationDrawerOperationDispatcher : public Super
{
private:
	static EquationDrawer	*m_drawer;
public:
	static void setDrawer(EquationDrawer *p) { m_drawer = p; }
	static void init() { m_drawer = 0; }

	void	draw(DrawContext *context)
	{
		assert(m_drawer);
		m_drawer->draw(this, context);
	}
#ifdef DRAW2D
	void	size(DrawContext *context, Equation::Size &sz) 
	{
		assert(m_drawer);
		m_drawer->size(this, context, sz);
	}

	const Length &centerWidth(DrawContext *context, Length &l)
	{
		assert(m_drawer);
		m_drawer->centerWidth(this, context, l);
		return l;
	}
#endif

#ifdef _DEBUG
	static bool check() { return m_drawer?true: false; }
#else
	static bool check() { return true;}
#endif
};

#define DRAWER_INSTANCIATION(Super, Dummy) EquationDrawer	*EquationDrawerOperationDispatcher<Super, Dummy>::m_drawer

#define DRAWER_INSTANCIATION_WITH_CLASS_NAME(ClassName) EquationDrawer	*ClassName::m_drawer

 

#endif  // EquationDrawerOperationDispatcher_h
