/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: EquationSize.h,v 1.3 2002/08/14 08:44:51 yoshi Exp $ */ 
#ifndef EquationSize_h
#define EquationSize_h

#include "Length.h"
#include <assert.h>

class EquationSize
{
private:
	Length	m_width;
	Length	m_height;


private:
	void	setNull() { m_width.value(0); m_height.value(0); }
public:
	bool	null()
	{
		return (m_width.value() == 0 || m_height.value() == 0)? true: false;
	}

	void	set(int w, int h)
	{
		m_width.value(w); m_height.value(h);
	}

	void	setCenter(int w, int h)
	{
		m_width.center(w); m_height.center(h);
	}

	int	width() { return m_width.value(); }
	int	height() { return m_height.value(); }
	Length	&widthLength() { return m_width; }
	Length  &heightLength() { return m_height; }

	EquationSize &operator=(const EquationSize &o)
	{
		this->m_width = o.m_width;
		this->m_height = o.m_height;
		return *this;
	}
	EquationSize &operator=(int n)
	{
		assert(n == 0); setNull();
		return *this;
	}
};


#endif  // EquationSize_h
