/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: IntegralEquation.h,v 1.6 2004/03/25 07:18:35 yoshi Exp $ */ 
#ifndef IntegralEquation_h
#define IntegralEquation_h

#include "ChildContainerEquation.h"
#include "EquationDrawerOperationDispatcher.h"
#include "EquationUtil.h"

class IntegralEquationDummy {};
typedef EquationDrawerOperationDispatcher<ChildContainerEquation, IntegralEquationDummy> IntegralEquationSuper;

class IntegralEquation 	: public IntegralEquationSuper
{
public:
	typedef IntegralEquationSuper Super;

private:
	Equation	*m_content;
	Equation	*m_lower;
	Equation	*m_upper;

	void		free_();
public:
	IntegralEquation();
	IntegralEquation(Equation *content, Equation *lower, Equation *upper);
	virtual ~IntegralEquation();

	void		content(Equation *p) { m_content = p; push(p);}
	void		lower(Equation *p) { m_lower = p; push(p);}
	void		upper(Equation *p) { m_upper = p; push(p);}

	Equation *	content() { return m_content; }
	Equation *	lower() { return m_lower; }
	Equation *	upper() { return m_upper; }
private:
	char *idName();
};

#endif  // IntegralEquation_h
