/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: Length.h,v 1.5 2003/09/05 04:34:23 yoshi Exp $ */ 
#ifndef Length_h
#define Length_h

/*
   NX

   Sʒuwł钷B

   ɂ͊OgƓg݂B

   |---------|---------------|
                     
   P1  P4    P3       P5     P2

   P1 : OgJn_
   P2 : OgI_
   P3 : S_
   P4 : gJn_
   P5 : gI_

   ŁA P1 <= P4 < P3 < P5 <= P2łB
 */

class Length
{
public:
	typedef	int Type;
private:
	// Og̒l
	Type	m_value;
	Type	m_center;

	// g̒l
	Type	m_innerStart;
	Type	m_innerEnd;
public:
	Length();
	Length(Type v);
	Length(Type v, Type c);
	Length(const Length &o);

	
	void	value(Type v);
	void	center(Type c) { m_center = c; }
	void	inner(Type s, Type e) { m_innerStart = s; m_innerEnd = e; }

	Type	value() const { return m_value; }
	Type	start_center() const { return m_center; }
	Type	end_center() const { return m_value - m_center; }
	Type	wide_side() const { return (start_center() > value()/2)?
				      start_center(): end_center(); }
	Type	innerStart() const { return m_innerStart; }
	Type	innerEnd() const { return m_innerEnd; }

	Length &operator=(const Length &o);
	/* ======================================================================
	   Length NX̂Z

	   n_璆S܂ŁASI_܂ł̂ꂼ꒷킹B

	                   center
	   L1      |----------|----------|
	   L2          |------|-------------|
	   L1 + L2 |----------|-------------|

	   ǉlintœnꂽꍇAɋϓɒǉB

	   L1       |----------|----------| 
	   L2                |---|
	   L1 + L2 |-----------|-----------|

	   ====================================================================== */
	Length &operator+=(const Length &o);
	Length &operator+=(int n);
};


#endif  // Length_h
