/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: MatrixStructuredEquation.cpp,v 1.3 2004/02/16 12:52:11 yoshi Exp $ */ 
#include <assert.h>
#include <memory.h>
#include "MatrixStructuredEquation.h"

void	MatrixStructuredEquation::init()
{
	memset(m_elements, 0x00, sizeof(m_elements));
}

#define MAX(a, b) (((a) > (b))? (a): (b))

void	MatrixStructuredEquation::updateIndex(int col, int row)
{
	m_col = MAX(col+1, m_col);
	m_row = MAX(row+1, m_row);
}

#ifdef _DEBUG
void	MatrixStructuredEquation::check_range(Column column, Row row)
{
	assert(0 <= row && row < ROW_ELEMENT_NUM);
	assert(0 <= column && column < COLUMN_ELEMENT_NUM);
}
#endif


#if 0
int	MatrixStructuredEquation::columnSize()
{
	int	col = 0;
	int	row = 0;
#if 1
	while (element(0, row)) {
		int	c = 0;
		while (element(c, row)) { c++; }
		col = MAX(c, col);
		row++;
	}
#else
	while (element(col, row)) { col++; }

#ifdef _DEBUG
	row = 1;
	int	n;
	while (element(n=0, row)) {
		while (element(n, row)) { n++; }
		assert(col == n);
		row++;
	}
#endif
#endif
	return col;
}


int	MatrixStructuredEquation::rowSize()
{
	int	col = 0;
	int	row = 0;
	while (element(col, 0)) {
		int	r = 0;
		while (element(col, r)) { r++; }
		row = MAX(r, row);
		col++;
	}
	return row;
}


#endif
