/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: MatrixStructuredEquation.h,v 1.5 2004/02/16 12:52:11 yoshi Exp $ */ 
#ifndef MatrixStructuredEquation_h
#define MatrixStructuredEquation_h

#include "ChildContainerEquation.h"
#include "EquationUtil.h"

class MatrixStructuredEquation : public ChildContainerEquation
{
private:
	enum {
		COLUMN_ELEMENT_NUM = 64,
		ROW_ELEMENT_NUM = 64,
	};

public:
	typedef int Column;
	typedef int Row;

private:
	Equation *	m_elements[COLUMN_ELEMENT_NUM][ROW_ELEMENT_NUM];
	int	m_col;
	int	m_row;

private:
	void	init();
	void	updateIndex(int c, int r);


public:
	MatrixStructuredEquation() : ChildContainerEquation(), m_col(0), m_row(0) { init(); }

#ifdef _DEBUG
	void	check_range(Column colomn, Row row);
#else
#define check_range(column, row) 
#endif
	void		element(Column column, Row row, Equation *p)
	{
		check_range(column, row);
		updateIndex(column, row);
		m_elements[column][row] = p;
		push(p);
	}
	Equation *	element(Column column, Row row)
	{
		check_range(column, row);
		return m_elements[column][row];
	}

	int	columnSize() { return m_col; }
	int	rowSize() { return m_row; }
};

#endif  // MatrixStructuredEquation_h
