/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: CharReplacerImpl.h,v 1.1 2001/10/18 05:57:24 yoshi Exp $ */ 
#ifndef CharReplacerImpl_h
#define CharReplacerImpl_h

#include "CharReplacer.h"
#include <string.h>

template<char FROM, char TO>
class CharReplacerImpl : public CharReplacer
{
private:
	int	m_num;

	int	newSize(int cnt, int nowsize)
	{
		return (nowsize + (m_num - 1)*cnt);
	}
public:
	CharReplacerImpl(int num) : CharReplacer(), m_num(num) {;}
	int mustReplace(char *);
	char *	exec(char *str, int &bufsize);
};

template<char FROM, char TO>
int CharReplacerImpl<FROM, TO>::
mustReplace(char *str)
{
	int	cnt = 0;
	for (char *p=str; *p; p++) {
		if (*p == FROM) { cnt++; }
	}
	return (cnt != 0)? newSize(cnt, strlen(str)+1): -1;
}


template<char FROM, char TO>
char * CharReplacerImpl<FROM, TO>::
//exec(char *from, char *to)
exec(char *str, int &bufsize)
{
	if ((bufsize = mustReplace(str)) < 0) { return str; }

	char *newbuf = new char [bufsize];
	char *pfrom = str;
	char *pto = newbuf;
	while(*pfrom) {
		if (*pfrom == FROM) {
			for (int i=0; i<m_num; i++) { *pto = TO; pto++; }
			pfrom++;
		} else { *pto++ = *pfrom++; }
	}
	return newbuf;
}


#endif  // CharReplacerImpl_h
