/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: UrlTextLineReadIterator.h,v 1.1 2001/11/28 09:04:49 yoshi Exp $ */ 
#ifndef UrlTextLineReadIterator_h
#define UrlTextLineReadIterator_h

#include <afxinet.h>
#include "TextLineReadIterator.h"

class UrlTextLineReadIterator : public TextLineReadIterator
{
private:
	CInternetSession	*m_session;
	CStdioFile *		m_file;
	CString			m_url;
	int			m_bufSize;
	char *			m_buf;
	int			m_line;

private:
	void	init();
	void	free_();
	void	open(const char *url);
	void	close();
	char *  readLine();
	bool	next();
public:

	UrlTextLineReadIterator() : TextLineReadIterator() { init(); }
	UrlTextLineReadIterator(const char *url)
		: TextLineReadIterator()
	{
		init(); m_url = url;
	}
	virtual ~UrlTextLineReadIterator() { free_(); }

	bool hasMoreElements() { return next(); }
	char *element() { return m_buf; }
	char *releaseElement();
	char *element(int);
	int  line() { return m_line; }
};
 

#endif  // UrlTextLineReadIterator_h
