/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: Math2DContextCreator.h,v 1.2 2003/09/16 09:11:47 yoshi Exp $ */ 
#ifndef Math2DContextCreator_h
#define Math2DContextCreator_h

#include "Math2DContextCreatorBase.h"

class HilightSwitch;
class EquationColor;
class EquationSizeManager;
class FontManager;

class Math2DContextCreator : public Math2DContextCreatorBase
{
private:
	long	&m_fontSize;
	long	&m_startNumber;
	int	&m_enum;

	HilightSwitch *		m_hSwitch;
	EquationColor *		m_color;
	EquationSizeManager *	m_sizeMgr;
	FontManager *		m_fontMgr;
private:
	HilightSwitch *		hilightSwitch();
	EquationSizeManager*	sizeMgr();

private:
	void	free_();
public:
	Math2DContextCreator(long &fs, long &sn, int &enum_);
	~Math2DContextCreator() { free_(); }
public:
	void	fontSize(int n) { m_fontSize = n; }
	int	fontSize() const { return m_fontSize; }
	void	startNumber(int n) {m_startNumber = n; }
	int	startNumber() const {
		if (m_startNumber > 0) { return m_startNumber;}
		return (m_enum)? 1: -1;
	}
	void	enumeration(bool b) { m_enum = b; }
	bool	enumeration() const { return m_enum? true: false; }

	void	color(unsigned normal_, unsigned hilight_, unsigned link_);
	FontManager&	fontManager();

private:
	DrawContext *create(EquationRegister *, EquationDictionaryBase *);
};

#endif // Math2DContextCreator_h
 
