/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: Math2DIniFileReader.cpp,v 1.2 2003/09/16 09:10:25 yoshi Exp $ */ 
#include "Math2DIniFileReader.h"

Math2DIniFileReader::Math2DIniFileReader(const char *fname)
	: m_fname(fname) {;}

static char s_buf[1024];

char	*Math2DIniFileReader::getFont(const char *key)
{
	DWORD ret;
	ret = GetPrivateProfileString("FONT", key, NULL, s_buf, sizeof(s_buf), m_fname.c_str());
	return (ret > 0)? s_buf: 0;
}

UINT	Math2DIniFileReader::getColor(const char *key)
{
	return GetPrivateProfileInt("COLOR", key, COLOR_NOT_SET, m_fname.c_str());
}

// tHg
char *	Math2DIniFileReader::stringNormalFacename() { return getFont("STRING_NORMAL");}
char *	Math2DIniFileReader::bigSymbolFacename() {return getFont("MATH_BIG_SYMBOL");}
char *	Math2DIniFileReader::operatorFacename() { return getFont("MATH_OPERATOR"); }
char *	Math2DIniFileReader::functionFacename() { return getFont("MATH_FUNCTION");}
char *	Math2DIniFileReader::paramFacename() { return getFont("MATH_PARAM"); }
char *	Math2DIniFileReader::bracketFacename() { return getFont("BRACKET"); }
char *  Math2DIniFileReader::arrowFacename() { return getFont("ARROW"); }
char *  Math2DIniFileReader::enumFacename() { return getFont("ENUMERATION"); }

// F
UINT	Math2DIniFileReader::normalColor() { return getColor("NORMAL"); }
UINT	Math2DIniFileReader::hilightColor() { return getColor("HILIGHT");}
UINT	Math2DIniFileReader::linkColor() { return getColor("LINK"); }

#ifdef MATH2DINIREADER_TEST

#define PRINT_FONT(KEY, RESULT) \
	if (RESULT) { printf("%s -> %s\n", KEY, RESULT); } \
	else { printf("%s -> NULL\n", KEY); }

#define PRINT_COLOR(KEY, RESULT) \
	if (Math2DIniFileReader::isValidColor(RESULT)) { printf("%s -> %06x\n", KEY, RESULT);} \
	else { printf("%s -> invalid\n", KEY); }


int main()
{
	const char *inifile = "c:\\prj\\ph\\paperhouse\\src\\main\\PHMath2D.ini";
	Math2DIniFileReader read(inifile);

	PRINT_FONT("STRING_NORMAL", read.stringNormalFacename());
	PRINT_FONT("BIG_SYNBOL", read.bigSymbolFacename());
	PRINT_FONT("OPERATOR", read.operatorFacename());
	PRINT_FONT("FUNCTION", read.functionFacename());
	PRINT_FONT("PARAM", read.paramFacename());
	PRINT_FONT("BRACKET", read.bracketFacename());
	PRINT_FONT("ARROW", read.arrowFaceename());
	PRINT_FONT("ENUMERATION", read.enumFacename());

	PRINT_COLOR("normal", read.normalColor());
	PRINT_COLOR("hilight", read.hilightColor());
	PRINT_COLOR("link", read.linkColor());	

	return 0;
}
#endif
