/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: Math2DIniFileWriter.cpp,v 1.1 2003/09/16 09:10:14 yoshi Exp $ */ 
#include <windows.h>
#include "Math2DIniFileWriter.h"

Math2DIniFileWriter::Math2DIniFileWriter(const char *fname) : m_fname(fname) {;}

bool Math2DIniFileWriter::writeString(const char *section, const char *key, const char *value)
{
	return WritePrivateProfileString(section, key, value, m_fname.c_str())? true: false;
}

bool Math2DIniFileWriter::writeFont(const char *key, const char *font)
{
	return writeString("FONT", key, font);
}

bool Math2DIniFileWriter::writeColor(const char *key, UINT v)
{
	char buf[128];
	sprintf(buf, "%d", v);
	return writeString("COLOR", key, buf);
}

#define IMPL_SET_FONT(METHOD, KEY_STR) \
bool Math2DIniFileWriter::##METHOD##(const char *str) { return writeFont(KEY_STR, str); }

IMPL_SET_FONT(stringNormalFacename, "STRING_NORMAL");
IMPL_SET_FONT(bigSymbolFacename, "MATH_BIG_SYMBOL");
IMPL_SET_FONT(operatorFacename, "MATH_OPERATOR");
IMPL_SET_FONT(functionFacename, "MATH_FUNCTION");
IMPL_SET_FONT(paramFacename, "MATH_PARAM");
IMPL_SET_FONT(bracketFacename, "BRACKET");
IMPL_SET_FONT(arrowFacename, "ARROW");
IMPL_SET_FONT(enumFacename, "ENUMERATION");

#define IMPL_SET_COLOR(METHOD, KEY_STR) \
bool Math2DIniFileWriter::##METHOD##(UINT V) { return writeColor(KEY_STR, V); } 

IMPL_SET_COLOR(normalColor, "NORMAL");
IMPL_SET_COLOR(hilightColor, "HILIGHT");
IMPL_SET_COLOR(linkColor, "LINK");


#ifdef M2DINIFILEWRITER_TEST
int main()
{
	Math2DIniFileWriter write("./foo.ini");

	write.stringNormalFacename("normal value");
	write.bigSymbolFacename("big");
	write.operatorFacename("op");
	write.functionFacename("foo var");
	write.paramFacename("p a r a m");
	write.bracketFacename("bracket");
	write.arrowFaceename("->");
	write.enumFacename("1 2 3");

	write.normalColor(0xff0000);
	write.hilightColor(0xffffff);
	write.linkColor(0x000000);

	return 0;
}
#endif

