/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: Math2DLoader.h,v 1.9 2003/10/02 10:18:50 yoshi Exp $ */ 
#ifndef Math2DLoader_h
#define Math2DLoader_h

#include "ErrorTextWriter.h"
#include "List.h"

class Equation;
class TextLineReadIterator;

class Math2DLoader
{
public:
	typedef List<Equation *> EquationContainer;
	typedef ListIterator<Equation *> EquationContainerIterator;
private:
	EquationContainer		m_equations;
	ErrorTextWriter			*m_err;
	int				m_line;

private:
	void	free_();
public:
	Math2DLoader();
	~Math2DLoader();
	void		set(ErrorTextWriter *p) { m_err = p; }

	bool	load(const char *file = 0);
	bool	operator()(const char *file) { return load(file); }
	bool	load(TextLineReadIterator &);

	EquationContainer& getContainer() { return m_equations; }
	void	clear() { free_(); }
	
	int	line() const { return m_line; }
};
 
#endif  // Math2DLoader_h
