/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: BinominalOperatorEquationParser.cpp,v 1.7 2003/12/15 08:18:18 yoshi Exp $ */
#include "BinominalOperatorEquationParser.h"
#include "EquationParserUtil.h"

#include <string.h>

#include "PlusEquation.h"
#include "MinusEquation.h"
#include "AsteriskEquation.h"
#include "BinominalOperatorEquationImpl.h"

// -- backslash start --
#define CAP_STR		"cap"
#define CUP_STR		"cup"
#define TIMES_STR	"times"
#define PLUS_MINUS_STR	"pm"
#define MINUS_PLUS_STR	"mp"
// -- backslash end --

#define MATCH_STRING(tar, key) EquationParserUtil::matchString(tar, key)

#define MATCH_STRING_RETURN_START() if (0)
#define MATCH_STRING_RETURN(target, key) else if (MATCH_STRING(target, key)) return true
#define MATCH_STRING_RETURN_END()  else return false


bool	BinominalOperatorEquationParser::match(char *str, int head)
{
	char * curr = str + head;
	char * next = curr + 1;
	char prev = (head > 0)? str[head-1]:0;

#define NOT_SUCCESSIVE ( (*curr != *next) && (*curr != prev) )
	switch(*curr) {
	case '+':
	case '*':
		return (NOT_SUCCESSIVE)? true: false;
	case '-':
		return ((NOT_SUCCESSIVE) && *next != '>') ? true: false;
		
	case '\\':
		MATCH_STRING_RETURN_START();
#define DEF_EQUATION(EQ, STR, TEX_DESC, TEX_OK, WINDRAW_OK) MATCH_STRING_RETURN(next, STR)
#include "BiOPs.h"
#undef DEF_EQUATION
		MATCH_STRING_RETURN_END();
	};

	return false;
}

#define MATCH_STRING_AND_CREATE_START() if(0) {

#define MATCH_STRING_AND_CREATE(target, str, ClassName) \
	} else if (MATCH_STRING(target, str)) { \
	 end = strlen(str); return new ClassName;

#define MATCH_STRING_AND_CREATE_END() }

OperatorEquation *BinominalOperatorEquationParser::matchOperator(char *buf, int &end)
{
	switch (*buf) {
	case '+': end = 0; return new PlusEquation;
	case '-': end = 0; return new MinusEquation;
	case '*': end = 0; return new AsteriskEquation;
	case '\\':
		char *next = buf + 1;
		MATCH_STRING_AND_CREATE_START();
#define DEF_EQUATION(EQ, STR, TEX_DESC, TEX_OK, WINDRAW_OK) MATCH_STRING_AND_CREATE(next, STR, EQ)
#include "BiOPs.h"
#undef DEF_EQUATION
		MATCH_STRING_AND_CREATE_END();
	};
	assert(0);
	return 0;
}
