/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: ComparativeOperatorEquationParser.cpp,v 1.22 2003/12/15 11:41:07 yoshi Exp $ */
#include "ComparativeOperatorEquationParser.h"
#include "QuotationPair.h"
#include "EquationParserUtil.h"

#include <string.h>

#include "EqualEquation.h"
#include "LessEquation.h"
#include "GreaterEquation.h"
#include "ComparativeOperatorEquationImpl.h"
#include "ArrowEquationImpl.h"

#define MATCH_STRING(tar, key) EquationParserUtil::matchString(tar, key)

#define MATCH_STRING_RETURN_START() if (0)
#define MATCH_STRING_RETURN(target, key) else if (MATCH_STRING(target, key)) return true
#define MATCH_STRING_RETURN_END()  else return false


bool ComparativeOperatorEquationParser::match(char *str, int head)
{
	const char c = str[head];
	switch (c) {
	case '&':  return true;
	case '=' : case '<': return true;
	case '>':
		if (head == 0) { return true;}
		return (str[head-1] != '-')? true: false;
	case '\\':			
		char *target = &str[head+1];
		MATCH_STRING_RETURN_START();
#define DEF_EQUATION(CLASS, STR, TEX_DESC, TEX_OK, WINDRAW_OK) MATCH_STRING_RETURN(target, STR)
#include "ArrowSymbols.h"
#include "CompOPs.h"
		MATCH_STRING_RETURN_END();
	}
#undef DEF_EQUATION

	return false;
}

#define MATCH_STRING_AND_CREATE_START() if(0) {

#define MATCH_STRING_AND_CREATE(target, str, ClassName) \
	} else if (MATCH_STRING(target, str)) { \
	 end = strlen(str); return new ClassName;


#define MATCH_STRING_AND_CREATE_END() }


OperatorEquation *ComparativeOperatorEquationParser::matchOperator(char *str, int &end)
{
	switch (*str) {
	case '=': end = 0; return new EqualEquation;
	case '<': end = 0; return new LessEquation; 
	case '>': end = 0; return new GreaterEquation;
	case '\\':
		char *target = str + 1;
		MATCH_STRING_AND_CREATE_START();

#define DEF_EQUATION(EQ, STR, TEX_DESC, TEX_OK, WINDRAW_OK) \
	MATCH_STRING_AND_CREATE (target, STR, EQ);
#include "ArrowSymbols.h"
#include "CompOPs.h"

		MATCH_STRING_AND_CREATE_END();
	}
#undef DEF_EQUATION

	assert(0);
	return 0;
}
