/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: LineChecker.cpp,v 1.2 2001/10/18 06:15:00 yoshi Exp $ */
#include "LineChecker.h"

inline bool isSpace(char c)
{
	return (c == ' ' || c == '\t')? true: false;
}

static char *skipSpace(char *str)
{
	char *p;
	for (p=str; *p; p++) { if (!isSpace(*p)) { return p; } }
	return 0;
}

inline bool isBlockSpliter(char c)
{
	return (c == '#' || isSpace(c))? true: false;
}

static bool isBlockSpliter(char *str)
{
	char *p;
	for (p=str; *p; p++) { if (!isBlockSpliter(*p)) { return false; } }
	return true;
}

inline bool isUnitSpliter(char c)
{
	return (c == '.' || isSpace(c));
}

static bool isUnitSpliter(char *str)
{
	char *p;
	for (p=str; *p; p++) { if (!isUnitSpliter(*p)) { return false; } }
	return true;
}
	

static bool isChangeLine(char *str, char *&end, char *&nextStart)
{
	return false;
}

LineChecker::Type LineChecker::check(char *line)
{
	char *start = skipSpace(line);
	if (!start) { return IGNORE; }

	if (isUnitSpliter(start)) { return (m_result.type = SPLIT_UNIT); }
	if (isBlockSpliter(start)) { return (m_result.type = SPLIT_BLOCK); }

	char *end, *nextStart;
	if (isChangeLine(start, end, nextStart)){;}

	NormalLine *normal = reinterpret_cast<NormalLine*>(&m_result);
	normal->type = NORMAL_LINE;
	normal->start = start - line;
	return NORMAL_LINE;
}

#ifdef DEBUG_checker

#include <stdio.h>

void printType(LineChecker::Type type)
{
	switch(type) {
	case LineChecker::NORMAL_LINE:
		printf("normal line\n"); break;
	case LineChecker::IGNORE:
		printf("ignore line\n"); break;
	case LineChecker::SPLIT_TABLE:
		printf("split table\n"); break;
	case LineChecker::SPLIT_BLOCK:
		printf("split block\n"); break;
	case LineChecker::CHANGE_LINE:
		printf("change line\n"); break;
	}
}
					     
		

int main()
{
	char buf[1024];
	char *splitblock = "\t ................   \t";
	char *splittable = "#######################    ";
	char *ignore = "     \t    ";
	char *normal = " f(x) = 0 ";

	LineChecker	check;


	LineChecker::Type type;
	strcpy(buf, splitblock);
	type = check(buf); printType(type);

	strcpy(buf, splittable);
	type = check(buf); printType(type);

	strcpy(buf, ignore);
	type = check(buf); printType(type);

	strcpy(buf, normal);
	type = check(buf); printType(type);
	LineChecker::NormalLine &nline =
		reinterpret_cast<LineChecker::NormalLine&>(check.result());
	printf("%s\n", &normal[nline.start]);

	return 0;
}

#endif
	

