/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: StringBlockHLineIterator.h,v 1.2 2001/11/01 07:30:36 yoshi Exp $ */ 
#ifndef StringBlockHLineIterator_h
#define StringBlockHLineIterator_h

#include "List.h"

class StringBlockUnit;

class StringBlockHLineIterator
{
public:
	typedef StringBlockUnit		Unit;
	typedef List<StringBlockUnit*> UnitContainer;
	typedef ListIterator<StringBlockUnit*> UnitContainerIterator;		
private:
	UnitContainerIterator	m_itr;
	int		m_currLine;
	int		m_widthSum;
	int		m_blockWidth;

private:
	void	clear();
	Unit	*next();
	Unit	*prev();
	Unit	*curr() { return m_itr.element(); }
	Unit	*first() { m_itr.first(); return m_itr.element(); }
	int	unitIndex(int blockIndex);
public:
	StringBlockHLineIterator();
	void	setBlockWidth(int width) { m_blockWidth	= width; }
	void	set(UnitContainer *p);
	void	setLineIndex(int line) { m_currLine = line; }
	int	size() { return m_blockWidth; }
	char	element(int i);
	int	totalLineIndex();
};


#endif  // StringBlockHLineIterator_h
