/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: Exception.h,v 1.3 2003/10/02 10:11:37 yoshi Exp $ */
#ifndef Exception_h
#define Exception_h


#include <string.h>

#include <stdarg.h>
#include <stdio.h>

#define SET_STR_OF_VARIABLE_ARGS(buf, fmt) \
{\
	va_list	args; \
	va_start(args, fmt); \
	vsprintf((buf), fmt, args); \
	va_end(args); }


// O̊	
class Exception
{
private:
	enum { BUFSIZE = 4096, };
protected:
	char	m_msg[BUFSIZE];
	Exception() { m_msg[0] = 0; }
public:
	void	push_string(const char *fmt, ...) {
		char buf[BUFSIZE];
		SET_STR_OF_VARIABLE_ARGS(buf, fmt);
		strcat(m_msg, buf);
	}
	char	*msg() { return m_msg; }
};
//#define EXCEPTION_DUMP
#ifndef EXCEPTION_DUMP
#define DEF_EXCEPTION(me, parent, name) \
class me : public parent {}
#else
#define DEF_EXCEPTION(me, parent, name) \
class me : public parent\
{\
public:\
	me() : parent() { push_string("%s :\n", name); }\
	me(const char *fmt, ...) : parent() { \
		push_string("%s : %d\n", __FILE__, __LINE__); \
		push_string("%s :\n", name); \
		SET_STR_OF_VARIABLE_ARGS(m_msg, fmt);\
		push_string(m_msg);\
		push_string(("\n"));\
	}\
}
#endif

#ifdef EXCEPTION_DUMP
#define EXCEPTION_SET_CODE_INFO(e) e.push_string("%s(%d) : ", __FILE__, __LINE__)
#else
#define EXCEPTION_SET_CODE_INFO(e)
#endif // _DEBUG


#define DTRY				try {
#define DCATCH				catch

#define DTHROW(Exc) \
{ Exc e; EXCEPTION_SET_CODE_INFO(e); e.push_string("\n"); throw e; }
	
#define DTHROW_MESSAGE(Exc, msg) \
{ Exc e; EXCEPTION_SET_CODE_INFO(e);  e.push_string msg; throw e; }


#define DCATCH_AND_THROW(Exc) \
catch (Exc &e) {EXCEPTION_SET_CODE_INFO(e);  e.push_string("\n"); throw e; }

#define DCATCH_AND_THROW_MESSAGE(Exc, msg) \
catch (Exc &e) {EXCEPTION_SET_CODE_INFO(e);  e.push_string msg; throw e; }



#define DCATCH_START(Exc) \
} catch (Exc &e) { EXCEPTION_SET_CODE_INFO(e); e.push_string("\n");

#define DCATCH_END() ;}


#define DCATCH_MESSAGE_START(Exc, msg) \
catch (Exc &e) {EXCEPTION_SET_CODE_INFO(e); e.push_string msg;

#define DCATCH_MESSAGE_END() }

#define DCATCH_AND_THROW_START(Exc) \
catch (Exc &e) { EXCEPTION_SET_CODE_INFO(e); e.push_string("\n");

#define DCATCH_AND_THROW_END()  throw e;}

#define DCATCH_AND_THROW_MESSAGE_START(Exc, msg) \
catch (Exc &e) { EXCEPTION_SET_CODE_INFO(e); e.push_string msg;

#define DCATCH_AND_THROW_MESSAGE_END() throw e;}

#endif /* Exception_h */
