/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: Math2DTexDrawer.h,v 1.7 2003/12/15 08:18:19 yoshi Exp $ */ 
#ifndef Math2DTexDrawer_h
#define Math2DTexDrawer_h

#include "ErrorTextWriter.h"

class Math2DLoader;
class EquationDrawer;
class DrawContext;
class TextLineReadIterator;

class Math2DTexDrawer
{
private:
	enum { DRAWERS_SIZE = 512, };
private:
	EquationDrawer	*m_drawers[DRAWERS_SIZE];
	int		m_drawerCnt;
	ErrorTextWriter	*m_err;
	Math2DLoader	*m_loader;

private:
	int	size() { return m_drawerCnt; }
	void	init();
	void	initDrawer();
	void	free_();

	Math2DLoader *	createLoader();
public:
	Math2DTexDrawer();
	~Math2DTexDrawer() { free_(); }

	void		set(ErrorTextWriter *p) { m_err = p; }

	bool	load(const char *fname);
	bool	load(TextLineReadIterator &itr);
	void	draw(DrawContext *context);
	int	line();
};
 
#endif // Math2DTexDrawer_h
