/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: PHBlockList.cpp,v 1.2 2004/01/28 14:23:41 yoshi Exp $ */ 
#include "PHBlockList.h"
#include <assert.h>
#include <string.h>

bool PHBlock::CounterNode::convert(const char *block)
{
	const int n = m_counter.value();
	m_counter.decr();
	// fNgO̒l]
	if (n > 0) { return m_convert; }

	Node *bn = next();
	return (bn)? bn->convert(block): !m_convert;
}
void PHBlock::CounterNode::notListHead()
{
	// Xg̐擪łȂΖ
	m_counter.zero(); 
}

void PHBlock::DefaultNode::pushBlock(const char *name)
{
	assert(m_num < ARRAY_SIZE);
	strcpy(m_blocks[m_num], name);
	m_num++;
}

bool PHBlock::DefaultNode::convert(const char *name)
{
	bool b = false;
	for (int i=0; i<m_num; i++) {
		const char *s = m_blocks[i];
		if (strcmp(s, name) == 0) {
			b = true;
			break;
		}
	}
	if (b) { return true; }
	Node *bn = next();
	return (bn)? bn->convert(name): false;
}

void	PHBlock::List::free_()
{
	Node *p,*next;
	for (p = m_head; p; p = next) {
		next = p->next();
		delete p;
	}
	m_head = 0;
}

void	PHBlock::List::push(Node *n)
{
	n->setNext(m_head);
	m_head = n;
}

bool	PHBlock::List::convert(const char *name)
{
	return (m_head)? m_head->convert(name): false;
}
