/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: PHBlockList.h,v 1.1 2004/01/19 12:18:31 yoshi Exp $ */ 
#ifndef PHBlockList_h
#define PHBlockList_h

namespace PHBlock {

	class Node
	{
	private:
		Node	*m_next;
		unsigned m_options;
	public:
		Node() : m_next(0), m_options(0x0) {;}
		virtual ~Node() {;}
		virtual void	 notListHead() = 0; 
		virtual bool convert(const char *block) = 0;

		void	setNext(Node *p) {
			m_next = p;
			if (m_next) { m_next->notListHead(); }
		}
		Node	*next() const { return m_next; }
	};

	class Counter
	{
	private:
		int	m_value;
	public:
		Counter(int v) : m_value(v) {;}
	public:
		// }CiXɂ͂ȂȂ
		void	decr() { if (m_value > 0) { m_value--; }}
		void	zero() { m_value = 0; }
		int	value() const { return m_value; }
	};

	class CounterNode : public Node
	{
	private:
		Counter	m_counter;
		bool    m_convert;
	public:
		CounterNode(int count_ , bool conv)
			: Node(), m_counter(count_), m_convert(conv) {;}
	private:
		bool convert(const char *block);
		void	notListHead();
	};

	class ConvertNode : public CounterNode
	{
	public:
		ConvertNode(int count_) : CounterNode(count_, true) {;}
	};
	
	class IgnoreNode : public CounterNode
	{
	public:
		IgnoreNode(int count_) : CounterNode(count_, false) {;}
	};

	class DefaultNode : public Node
	{
	private:
		enum { ARRAY_SIZE = 10, };
	private:
		char	m_blocks[ARRAY_SIZE][128];
		int	m_num;
	public:
		DefaultNode() : Node(), m_num(0) {;}
		void	pushBlock(const char *name);
	private:
		bool	convert(const char *name);
		void	notListHead() {;}
	};

	/*
	  NodeXgɎnŒǉĂB
	  ₢킹ہAKvłΌÂm[hɔfς˂B
	  (Design Pattern  '炢񂵃p^[')
	 */
	class List
	{
	private:
		Node	*m_head;
	private:
		void	free_();
	public:
		List() : m_head(0) {;}
		~List() { free_(); }

		void	push(Node *);
		bool	convert(const char *name);
	};
}

#endif // PHBlockList_h
 
