/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: PHTexBlockConverter.h,v 1.7 2004/02/16 04:28:15 yoshi Exp $ */ 
#ifndef PHTexBlockConverter_h
#define PHTexBlockConverter_h

#ifdef WIN32
#pragma warning(disable:4786)
#endif

#include <string>
#include <stdio.h>
#include "PHTexBlockParseListener.h"
#include "PHTexBlockContext.h"

class PHTexBlockConverter : public PHTexBlockParseListener
{
	class Options
	{
	private:
		unsigned	m_opts;
		unsigned	m_negOpts;
	public:
		Options() : m_opts(0x0), m_negOpts(0x0) {;}
		void		set(unsigned v, unsigned nv);
		void		tokenize(const char *);
		unsigned	apply(unsigned v) const;
		void	clear() { m_opts = 0x0; m_negOpts = 0x0; }
	};
	
	class BlockOptions
	{
	private:
		Options	m_cmdline;
		Options	m_default;
		Options	m_thisOpts;
	public:
		void	commandLine(unsigned v) { m_cmdline.set(v, 0x0); }
		void	setDefaultArgs(const char *args) { m_default.tokenize(args); }
		void	setArgs(const char *args) { m_thisOpts.tokenize(args); }
		unsigned value() const;
		unsigned apply(unsigned v) const;
		void	clearArgs() { m_thisOpts.clear(); }
	};
public:
	FILE	*	m_fout;
	BlockOptions	m_options;
	bool		m_convert;
	bool		m_firstLine; // Lq̍ŏCł邩H
	std::string	m_blockName; // \begin{} ... \end{} ̃ubN
	PHTexBlockContext	m_context;
	PHTexBlockContext::DefaultBlock *m_default;
	unsigned	m_defaultOptions;
	int		m_blockLevel; // ubN̐[
public:
	PHTexBlockConverter();
	bool	convert(FILE *in, FILE *out, unsigned op);
	bool	operator()(FILE *in, FILE *out, unsigned op)
	{
		return convert(in, out, op);
	}

private:
	void defaultBlock(const char *name);
	void defaultOption(const char *);
	void convertBlock(int n);
	void ignoreBlock(int n);
	void blockOption(const char *);
	Error startBlock(const char *name, int level);
	Error endBlock(const char *name, int level);
	void line(int, const char *str);
};


#endif // PHTexBlockConverter_h
 
