/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: PHTexParam.h,v 1.2 2004/05/06 05:11:16 yoshi Exp $ */ 
#ifndef PHTexParam_h
#define PHTexParam_h

#include "PHTexParamBase.h"
#include "DrawContext.h"

class PHTexParam : public PHTexParamBase
{
private:
	DrawContext	m_context; // p[^ۑp
	TextLineReadIterator*	m_readItr;
	bool		m_freeReadItr;

	TextWriter *	m_writer;
	bool		m_freeWriter;

	bool		m_document;
	bool		m_sameLineNumber;
	
private:
	TextWriter*	writer();
	void		free_();
public:
	PHTexParam();
	~PHTexParam() { free_(); }
public:
	void	inputFilename(char *fname);
	void	setInputStream(TextLineReadIterator *itr) { m_readItr = itr; m_freeReadItr = false; }
	
	bool	outputFilename(char *fname);
	void	setOutputStream(TextWriter *p) { m_writer = p; m_freeWriter = false; }
	void	document(bool b) { m_document = b; }
	void	enumerate(bool b) { m_context.enumerate(b); }
	void	newline(bool b) { m_context.newline(b); }
	void    newlineAsTexComment(bool b) { m_context.newlineAsTexComment(b); }
	void	tag(bool b) { m_context.name(b); }
	void	rawDescription(bool b) { m_context.rawDescription(b); }
	void    nttJlatexMode() { m_context.texType().nttJlatex(); }
	void    asciiPlatexMode() { m_context.texType().asciiPlatex(); }
	void    sameLineNumber(bool b) { m_sameLineNumber = b; }
	void    equationBlock(bool b) { m_context.equationBlock(b); }
private:
	DrawContext *create(EquationDictionaryBase *dic);
	TextLineReadIterator &readItr();
	bool	document() { return m_document; }
	bool	sameLineNumber() { return m_sameLineNumber; }
};


#endif // PHTexParam_h
 
