/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: PHTexRC.cpp,v 1.1 2003/10/02 10:16:43 yoshi Exp $ */ 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "IOUtil.h"

static char *getRCFile()
{
	static char fname[1024];
	char *home = getenv("HOME");

	if (!home) { return 0; }
	strcpy(fname, home);
	strcat(fname, "/.ph2texrc");
	return fname;
}

#define ARRAY_SIZE(ARY) (sizeof(ARY)/sizeof(ARY[0]))

#define TOKENS " \t\n="

#ifdef __cplusplus
#define EXTERN_C_START() extern "C" {
#define EXTERN_C_END() }
#endif

EXTERN_C_START();

char **PHTexRCGetOptions(char *appname, int *n)
{
	static char argsbuf[128][256];
	static char *args[128];


	FILE *	fp;
	char buf[1024];
	char line[1024];

	int	i;
	int	cnt = 0;
	char *fname = getRCFile();

	if (!fname) { return 0; }
	
	fp = fopen(fname, "r");
	if (!fp) { return 0; }

	for (i=0; i<ARRAY_SIZE(args); i++) {
		args[i] = argsbuf[i];
	}
	
	strcpy(args[cnt], appname); cnt++;

	for (int l=1; fgets(buf, sizeof(buf), fp) != 0; l++) {
		IOUtil::chomp(buf);
		strcpy(line, buf);
		if (line[0] == '#' || line[0] == '%') { continue;}
		
		char *p = strtok(line, TOKENS);
		if (strcmp(p, "options") == 0 ||
		    strcmp(p, "option") == 0) {
			
			while ((p = strtok(NULL, TOKENS)) != 0) {
				strcpy(args[cnt], p);
				cnt++;
			}
		} else {
			fprintf(stderr,
				"unsupported description in %s\n"
				"%d : %s\n",
				fname, l, buf);
			fprintf(stderr, "ignored...\n");
			continue;
		}
	}

	fclose(fp);
	*n = cnt;
	return (cnt > 1)? args: 0;
}

EXTERN_C_END();

#ifdef RC_TEST
int main(int argc, char **argv)
{
	int i;
	int n;
	char **args = PHTexRCGetOptions(argv[0], &n);
	if (!args) {
		printf("no file\n");
		return 1;
	}
	for (i=0; i<n; i++) {
		printf("%s\n", args[i]);
	}
	return 0;
}
#endif
		
