/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: FileUtil.h,v 1.1 2003/10/06 11:14:50 yoshi Exp $ */ 
#ifndef FileUtil_h
#define FileUtil_h

#include <sys/stat.h>
#include <sys/types.h>
#ifdef WIN32
#include <direct.h>
#include <io.h>
#endif

class FileUtil
{
public:
	static char*	spliterStr();
	static int	spliterLength();
	static char *	removeSpliter(char *dir);
	static char *	filename(const char *parent, const char *name, char *buf);
	static char *	filenameHead(char *str);
	static struct stat *fileExist(const char *fname)
	{
		static struct stat st_buf;
		return (::stat(fname, &st_buf) != -1)? &st_buf: 0;
	}

	static bool isDirectory(struct stat *st) {
		return ((st->st_mode & S_IFMT) == S_IFDIR )? true: false;
	}

	static bool isDirectory(const char *fname)
	{
		struct stat *st = fileExist(fname);
		if (!st) { return false; }
		return ((st->st_mode & S_IFMT) == S_IFDIR )? true: false;
	}
	static bool	mkdir(const char *dirname)
	{
		const int FULL_ACCESS = 0x1ff;
#ifdef WIN32
		if (_mkdir(dirname) == -1) { return false; }
		if (_chmod(dirname, FULL_ACCESS) == -1) { return false; } // 0x1ff = full access(777)
		return true;
#else
		return (::mkdir(dirname, FULL_ACCESS) != -1)? true: false;
#endif
	}

	static bool	move(const char *from, const char *to);
	static bool 	recurMkdir(const char *dirname);
	static bool     remove(const char *fname);
	static bool	touch(const char *fname);
	static bool	copy(const char *src, const char *to);
};


#endif  // FileUtil_h
