/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: Map.h,v 1.2 2002/01/08 04:26:12 yoshi Exp $ */ 
#ifndef Map_h
#define Map_h

#ifdef WIN32
#pragma warning(disable:4786)
#endif

#include <map>

template<class Key, class T, class Cmp=std::less<Key> >
class Map : public std::map<Key, T, Cmp>
{
private:
	typedef std::map<Key, T, Cmp> Super;
public:
	void	set(Key key, T t)
	{
		insert(std::pair<Key, T>(key, t));
	}

	T 	get(Key key)
	{
		Super::iterator itr = find(key);
		return (itr != end())? itr->second: 0;
	}
};

template<class Key, class T, class Cmp=std::less<Key> >
class MapIterator
{
private:
	typedef Map<Key, T, Cmp> MapType;	
	typedef Map<Key, T, Cmp>::iterator MapIteratorType;	
private:
	MapType *		m_map;
	MapIteratorType	*	m_curr;

private:
	void	free_() { if (m_curr) { delete m_curr; m_curr = 0; } }
public:
	MapIterator(Map<Key, T, Cmp> *map) : m_map(map), m_curr(0) {;}
	virtual ~MapIterator() { free_(); }

	bool	hasMoreElements()
	{
		if (!m_curr) {
			m_curr = new MapIteratorType;
			*m_curr = m_map->begin();
		} else { (*m_curr)++; }
		if (*m_curr == m_map->end()) {
			delete m_curr; m_curr = 0;
			return false;
		}
		return true;
	}

	T	element() { return (m_curr)? (*(*m_curr)).second: 0; }
};


#endif  // Map_h
