/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: MultiMap.h,v 1.1 2001/11/08 08:56:09 yoshi Exp $ */ 
#ifndef MultiMap_h
#define MultiMap_h

#include <map>

template<class Key, class T>
class MultiMap : public std::multimap<Key, T>
{
private:
	//	typedef Pair<Key, T> MapPair;
public:
	void	add(Key &key, T &t)
	{
		insert(std::pair<Key, T>(key, t));
	}
		       
};

template<class Key, class T>
class MultiMapIterator
{
private:
	MultiMap<Key, T> *		m_map;
	MultiMap<Key, T>::iterator	m_upper;
	MultiMap<Key, T>::iterator	m_lower;
	MultiMap<Key, T>::iterator	*m_curr;

private:
	void	free_() { if (m_curr) { delete m_curr; m_curr = 0; } }
public:
	MultiMapIterator(MultiMap<Key, T> *map) : m_map(map), m_curr(0) {;}
	virtual ~MultiMapIterator() { free_(); }

	bool	find(Key key) {
		if  (!m_map) { return false; }
		m_upper = m_map->upper_bound(key);
		m_lower = m_map->lower_bound(key);
		return (m_upper != m_lower)? true: false;
	}

	bool	findAll() {
		if (!m_map) { return false; }
		m_upper = m_map->end();
		m_lower = m_map->begin();
		return (m_upper != m_lower)? true: false;
	}

	bool	hasMoreElements()
	{
		if (!m_curr) {
			m_curr = new MultiMap<Key, T>::iterator;
			*m_curr = m_lower;
		} else { (*m_curr)++; }

		if (*m_curr == m_upper) {
			delete m_curr; m_curr = 0;
			return false;
		}
		return true;
	}

	T	element() { return (m_curr)? (*(*m_curr)).second: 0; }
};

#endif  // MultiMap_h
