/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: hash.c,v 1.1 2002/09/24 08:11:32 yoshi Exp $ */
/* schash .... separate chaining hash */

#ifdef DEBUG_hash
#define Static /* nothing */
#else
#define Static static
#endif

#include <stdio.h>
#include <string.h>
#include "hash.h"

/* s0 .. for String version 0(simple) */
size_t hash_s0(const unsigned char *key, size_t tblsiz)
{
  size_t ans;

  ans = 0;
  while (*key) {
    /* ans = ((ans << 8) + ans + (*key << 3) + *key) % tblsiz; */
    ans = ((ans << 8) + ans + (*key)) % tblsiz;
    key++;
  }
  return ans;
}


#if 0


int hash_s1(char *key, int tblsiz)
{
  unsigned ans;

  ans = 0;
  while (*key) {
    ans += (ans << 3) + (*key);
    key++;
  }
  return ans % tblsiz;
}

size_t hash_s2(char *key, size_t tblsiz)
{
  char *p;
  unsigned h = 0, g;
  for (p = key; *p; p++) {
    h = (h << 4) + (*p);
    if (g = h & 0xf0000000) {
      h = h ^ (g >> 24);
      h = h ^ g;
    }
  }
  return h % tblsiz;
}
    
/* m0 .. for Mem version 0(simple) */
size_t hash_m0(unsigned char *key, size_t keylen, size_t tblsiz)
{
  size_t ans, i;

  ans = 0;
  i = 0;
  while (i < keylen) {
    ans = ((ans << 8) + key[i]) % tblsiz;
    i++;
  }
  return ans;
}

#ifdef DEBUG_hash_pgm
int main(void)
{
  char buf[BUFSIZ];
  unsigned u = 0;
  printf("unsigned = %d\n", sizeof u);
  while (gets(buf)) {
    printf("%4d %4d\n",
					 hash_s2(buf, 1031),
					 hash_s1(buf, 1031));

  }
  return 0;
}
#endif
#endif
