/*
 MatEx-2D Tools

 [Copyright holders' statement]
 MatEx-2D Tools is a package of softwares which are realization of
 Ishiguro's original idea of 2-dim. mathematical expression parser 
 by Saito of Mathematical Systems Inc. We distribute this software 
 from ISMLIB of the Institute of Statistical Mathematics, ISM
 ( http://www.ism.ac.jp/ismlib/index_e.html ) under the conditions 
 of Open Market License(version:OML-SW-E-1996) proposed by 
 ISM( /http://www.ism.ac.jp/ismlib/license_e.html). The OML allows 
 the free use of the source code, including redistribution and 
 modification as far as the whole of this copyright holders' statement
 is copied and shown conspicuously in the redistribution or the 
 modified version or the document attached to the products made 
 utilizing MatEx-2D Tools.

 Copyright holders take no responsibility for any damage caused by the
 use of this software.

 Copyright_OML 2004
 ISHIGURO, Makio, the Institute of Statistical Mathematics
 SAITO, Muneyoshi, Mathematical Systems Inc.
 [End of Copyright holders' statement]
*/
/* $Id: schash.h,v 1.1 2002/09/24 08:11:34 yoshi Exp $ */
#ifndef schash_h
#define schash_h

#ifdef __cplusplus
extern "C" {
#endif

#ifndef SCHASH_TYPE
typedef int type;
#else
typedef SCHASH_TYPE type;
#endif

typedef union upt {
  void *p;
  type t;
} upt;

typedef struct kvunit {
  const char *key;
  upt val;
  struct kvunit *next;
} kvunit;

typedef struct schash {
  kvunit **tbl;
  size_t tblsiz;

  size_t tblitr;
  kvunit *kvitr;

  size_t (*hash)(const unsigned char *, size_t);

} schash;

extern void schash_set_calloc(void *(*org_calloc)(size_t, size_t));

extern kvunit *kvunit_new(void);
extern void kvunit_delete(kvunit *u);
extern size_t kvunit_length(kvunit *unit);

extern schash *schash_new(size_t l);
extern void schash_delete(schash *h);

extern void schash_set_hash(schash *h, size_t (*org_hash)(const unsigned char *, size_t));

extern kvunit *schash_insert(schash *h, const char *k, upt v, kvunit *reuse);
extern kvunit *schash_insertp(schash *h, const char *k, void *v, kvunit *reuse);
extern kvunit *schash_insertt(schash *h, const char *k, type v, kvunit *reuse);

extern kvunit *schash_find(schash *h, const char *k);
extern upt schash_find_value(schash *h, const char *k);
extern kvunit *schash_remove(schash *h, const char *k);

extern kvunit *schash_first(schash *h);
extern kvunit *schash_next(schash *h);

extern const char *schash_first_each(schash *h, upt *vp);
extern const char *schash_next_each(schash *h, upt *vp);


extern size_t schash_length(schash *h);

extern schash *schash_rehash(schash *befh, size_t newlen);
extern int schash_histgram(schash *h, const char *format);

#ifdef __cplusplus
}
#endif

#endif /* schash_h */
